"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getLatLngByAddress=exports.getDistanceBetweenPoints=exports.getLatLngCenterPoint=void 0;var _validations=require("../validations");var _getType=_interopRequireDefault(require("../getType"));var _webStorageData=require("../webStorageData");var _urlParams=require("../urlParams");var _apiCall=_interopRequireDefault(require("../apiCall"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{"default":obj}}function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg);var value=info.value}catch(error){reject(error);return}if(info.done){resolve(value)}else{Promise.resolve(value).then(_next,_throw)}}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise(function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(undefined)})}}var getLatLngCenterPoint=function getLatLngCenterPoint(geoPoints){if(_validations.validations.isEmpty(geoPoints))return undefined;var latLngPoints=geoPoints;if((0,_getType["default"])(geoPoints)==="string")latLngPoints=geoPoints.split(";");var totalPoints=latLngPoints.length;if(totalPoints<2)return undefined;var points=latLngPoints.reduce(function(dataResult,currentItem){var currentLatLngAsArray=currentItem.split(",");if(currentLatLngAsArray.length!==2)return dataResult;var tempData={lat:parseFloat(dataResult.lat)+parseFloat(currentLatLngAsArray[0]),lng:parseFloat(dataResult.lng)+parseFloat(currentLatLngAsArray[1])};return tempData},{lat:0,lng:0});var latLngMiddleAsArray=[points.lat/totalPoints,points.lng/totalPoints];if(latLngMiddleAsArray.includes(NaN))return undefined;return latLngMiddleAsArray.join(",")};exports.getLatLngCenterPoint=getLatLngCenterPoint;var getDistanceBetweenPoints=function getDistanceBetweenPoints(geoPoints){if(_validations.validations.isEmpty(geoPoints))return undefined;var latLngPoints=geoPoints;if((0,_getType["default"])(geoPoints)==="string")latLngPoints=geoPoints.split(";");var totalPoints=latLngPoints.length;if(totalPoints!==2)return undefined;var points=latLngPoints.reduce(function(dataResult,currentItem){var currentLatLngAsArray=currentItem.split(",");if(currentLatLngAsArray.length!==2)return dataResult;var tempData=dataResult;tempData.push({lat:currentLatLngAsArray[0],lng:currentLatLngAsArray[1]});return tempData},[]);var eartRadiusKm=6371.071;var point1LatRadian=points[0].lat*(Math.PI/180);var point2LatRadian=points[1].lat*(Math.PI/180);var latRadian=Math.abs(point1LatRadian-point2LatRadian);var lngRadian=(points[0].lng-points[1].lng)*(Math.PI/180);var distance=2*eartRadiusKm*Math.asin(Math.sqrt(Math.sin(latRadian/2)*Math.sin(latRadian/2)+Math.cos(point1LatRadian)*Math.cos(point2LatRadian)*Math.sin(lngRadian/2)*Math.sin(lngRadian/2)));return distance};exports.getDistanceBetweenPoints=getDistanceBetweenPoints;var getLatLngFromGoogleAPI=function(){var _ref2=_asyncToGenerator(regeneratorRuntime.mark(function _callee(_ref){var _getResponse$headers,_getResponse$headers$,_getResponse$headers$2;var _ref$googleAPIKey,googleAPIKey,_ref$localStorageKey,localStorageKey,_ref$storageType,storageType,addressKey,_ref$language,language,addressAsString,params,urlParams,url,getResponse,contentType,isJsonResponse,_result$geometry,response,status,result,latLng,mapsCoordinates;return regeneratorRuntime.wrap(function _callee$(_context){while(1){switch(_context.prev=_context.next){case 0:_ref$googleAPIKey=_ref.googleAPIKey,googleAPIKey=_ref$googleAPIKey===void 0?undefined:_ref$googleAPIKey,_ref$localStorageKey=_ref.localStorageKey,localStorageKey=_ref$localStorageKey===void 0?"mapsCoordinates":_ref$localStorageKey,_ref$storageType=_ref.storageType,storageType=_ref$storageType===void 0?"localStorage":_ref$storageType,addressKey=_ref.addressKey,_ref$language=_ref.language,language=_ref$language===void 0?"en":_ref$language;if(!(_validations.validations.isEmpty(addressKey)||_validations.validations.isEmpty(googleAPIKey))){_context.next=3;break}return _context.abrupt("return",undefined);case 3:addressAsString=addressKey.replaceAll("-"," ");params={address:addressAsString,key:googleAPIKey,language:language};urlParams=(0,_urlParams.objectAsUrlParams)(params);url="//maps.googleapis.com/maps/api/geocode/json".concat(urlParams);_context.next=9;return(0,_apiCall["default"])({url:url,method:"POST",headers:{"content-type":"application/x-www-form-urlencoded"},cache:"force-cache",mode:"cors",credentials:"omit"});case 9:getResponse=_context.sent;contentType=getResponse===null||getResponse===void 0?void 0:(_getResponse$headers=getResponse.headers)===null||_getResponse$headers===void 0?void 0:(_getResponse$headers$=_getResponse$headers.get("content-type"))===null||_getResponse$headers$===void 0?void 0:(_getResponse$headers$2=_getResponse$headers$.split(";"))===null||_getResponse$headers$2===void 0?void 0:_getResponse$headers$2.shift();isJsonResponse=contentType==="application/json";if(!(getResponse.ok&&isJsonResponse)){_context.next=29;break}_context.next=15;return getResponse.json();case 15:response=_context.sent;status=response.status.toLowerCase();if(!(status!=="ok")){_context.next=20;break}if(status==="over_query_limit"){setTimeout(function(){getLatLngFromGoogleAPI({googleAPIKey:googleAPIKey,localStorageKey:localStorageKey,storageType:storageType,addressKey:addressKey,language:language})},250)}return _context.abrupt("return",undefined);case 20:_context.next=22;return response.results[0];case 22:result=_context.sent;latLng=result===null||result===void 0?void 0:(_result$geometry=result.geometry)===null||_result$geometry===void 0?void 0:_result$geometry.location;if(!((0,_getType["default"])(latLng)==="object"&&_validations.validations.isNotEmpty(latLng===null||latLng===void 0?void 0:latLng.lat,true)&&_validations.validations.isNotEmpty(latLng===null||latLng===void 0?void 0:latLng.lng,true))){_context.next=29;break}mapsCoordinates=(0,_webStorageData.getStorageItem)(localStorageKey,storageType)||{};mapsCoordinates[addressKey]=latLng;(0,_webStorageData.setStorageItem)(localStorageKey,mapsCoordinates,storageType);return _context.abrupt("return",latLng);case 29:return _context.abrupt("return",undefined);case 30:case"end":return _context.stop();}}},_callee)}));return function getLatLngFromGoogleAPI(_x){return _ref2.apply(this,arguments)}}();var getLatLngFromGeoService=function(){var _ref4=_asyncToGenerator(regeneratorRuntime.mark(function _callee2(_ref3){var _getResponse$headers2,_getResponse$headers3,_getResponse$headers4;var address,_ref3$localStorageKey,localStorageKey,_ref3$storageType,storageType,addressKey,urlParams,url,getResponse,contentType,isJsonResponse,response,_ref5,location,latLng,mapsCoordinates;return regeneratorRuntime.wrap(function _callee2$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:address=_ref3.address,_ref3$localStorageKey=_ref3.localStorageKey,localStorageKey=_ref3$localStorageKey===void 0?"mapsCoordinates":_ref3$localStorageKey,_ref3$storageType=_ref3.storageType,storageType=_ref3$storageType===void 0?"localStorage":_ref3$storageType,addressKey=_ref3.addressKey;if(!(_validations.validations.isEmpty(address)||_validations.validations.isEmpty(addressKey))){_context2.next=3;break}return _context2.abrupt("return",undefined);case 3:urlParams=(0,_urlParams.objectAsUrlParams)(address);url="//api.wearekate.com/api/geocode".concat(urlParams);_context2.next=7;return(0,_apiCall["default"])({url:url,method:"GET",headers:{"content-type":"application/x-www-form-urlencoded"},cache:"force-cache",mode:"cors",credentials:"omit"});case 7:getResponse=_context2.sent;contentType=getResponse===null||getResponse===void 0?void 0:(_getResponse$headers2=getResponse.headers)===null||_getResponse$headers2===void 0?void 0:(_getResponse$headers3=_getResponse$headers2.get("content-type"))===null||_getResponse$headers3===void 0?void 0:(_getResponse$headers4=_getResponse$headers3.split(";"))===null||_getResponse$headers4===void 0?void 0:_getResponse$headers4.shift();isJsonResponse=["application/json","text/plain"].includes(contentType);if(!(getResponse.ok&&isJsonResponse)){_context2.next=22;break}_context2.next=13;return getResponse.json();case 13:response=_context2.sent;if(!((0,_getType["default"])(response)==="object"&&response!==null&&response!==void 0&&response.geometry)){_context2.next=22;break}_ref5=response.geometry||{},location=_ref5.location;latLng={lat:parseFloat(location.lat),lng:parseFloat(location.lng)};if(Object.values(latLng).includes(NaN)){_context2.next=22;break}mapsCoordinates=(0,_webStorageData.getStorageItem)(localStorageKey,storageType)||{};mapsCoordinates[addressKey]=latLng;(0,_webStorageData.setStorageItem)(localStorageKey,mapsCoordinates,storageType);return _context2.abrupt("return",latLng);case 22:return _context2.abrupt("return",undefined);case 23:case"end":return _context2.stop();}}},_callee2)}));return function getLatLngFromGeoService(_x2){return _ref4.apply(this,arguments)}}();var getLatLngByAddress=function(){var _ref7=_asyncToGenerator(regeneratorRuntime.mark(function _callee3(_ref6){var address,_ref6$googleAPIKey,googleAPIKey,prefixStorageKey,_ref6$storageType,storageType,_ref6$language,language,localStorageKey,mapsCoordinatesFromStorage,addressKey,latLngFromStorage,latLngFromGeoService,latLngFromGoogleAPI;return regeneratorRuntime.wrap(function _callee3$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:address=_ref6.address,_ref6$googleAPIKey=_ref6.googleAPIKey,googleAPIKey=_ref6$googleAPIKey===void 0?undefined:_ref6$googleAPIKey,prefixStorageKey=_ref6.prefixStorageKey,_ref6$storageType=_ref6.storageType,storageType=_ref6$storageType===void 0?"localStorage":_ref6$storageType,_ref6$language=_ref6.language,language=_ref6$language===void 0?"en":_ref6$language;if(!_validations.validations.isEmpty(address)){_context3.next=3;break}return _context3.abrupt("return",undefined);case 3:localStorageKey=prefixStorageKey?"".concat(prefixStorageKey,"MapsCoordinates"):"mapsCoordinates";mapsCoordinatesFromStorage=(0,_webStorageData.getStorageItem)(localStorageKey,storageType)||{};addressKey=[address.street,address.street_number,address.postal_code,address.city].join("-").replace(/\s+/g,"-").toLocaleLowerCase();if(!_validations.validations.isNotEmpty(mapsCoordinatesFromStorage,true)){_context3.next=10;break}latLngFromStorage=mapsCoordinatesFromStorage[addressKey]||undefined;if(!_validations.validations.isNotEmpty(latLngFromStorage,true)){_context3.next=10;break}return _context3.abrupt("return",latLngFromStorage);case 10:_context3.next=12;return getLatLngFromGeoService({address:address,localStorageKey:localStorageKey,storageType:storageType,addressKey:addressKey});case 12:latLngFromGeoService=_context3.sent;if(!((0,_getType["default"])(latLngFromGeoService)==="object")){_context3.next=15;break}return _context3.abrupt("return",latLngFromGeoService);case 15:if(!_validations.validations.isEmpty(googleAPIKey)){_context3.next=17;break}return _context3.abrupt("return",undefined);case 17:_context3.next=19;return getLatLngFromGoogleAPI({googleAPIKey:googleAPIKey,localStorageKey:localStorageKey,storageType:storageType,addressKey:addressKey,language:language});case 19:latLngFromGoogleAPI=_context3.sent;return _context3.abrupt("return",latLngFromGoogleAPI);case 21:case"end":return _context3.stop();}}},_callee3)}));return function getLatLngByAddress(_x3){return _ref7.apply(this,arguments)}}();exports.getLatLngByAddress=getLatLngByAddress;