"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.isElementValid=exports.getValidationTypes=exports.formPostValidation=exports.validations=void 0;var _getType=_interopRequireDefault(require("../getType"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{"default":obj}}var inValidCharactersLength=function inValidCharactersLength(value){var lengthCharacters=arguments.length>1&&arguments[1]!==undefined?arguments[1]:0;var isMinimal=arguments.length>2&&arguments[2]!==undefined?arguments[2]:true;var returnBoolean=arguments.length>3&&arguments[3]!==undefined?arguments[3]:false;var isValidValueType=["string","number"].includes((0,_getType["default"])(value));if(!isValidValueType)return{error:true,message:"value is not a string or number"};var validationType=isMinimal?"minimal":"maximum";var valueLength=value.toString().trim().length;var inValid=isMinimal?valueLength<lengthCharacters:valueLength>lengthCharacters;if(returnBoolean)return inValid;var errorMessage=inValid&&"must have ".concat(validationType," ").concat(lengthCharacters," characters");var message={error:inValid,message:errorMessage};return message};var validations={email:function email(value){var errorMessage="Is not a valid emailaddress";var pattern=/^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;var inValid=!pattern.test(String(value).toLowerCase());var message={error:inValid,message:inValid?errorMessage:undefined};return message},isEmpty:function isEmpty(value){var valueIsType=(0,_getType["default"])(value);switch(valueIsType){case"string":return value.trim().length===0;case"array":return value.length===0;case"object":return Object.keys(value).length===0;case"number":return Number.isNaN(value);case"boolean":return false;default:return true;}},isNotEmpty:function isNotEmpty(value){var returnBoolean=arguments.length>1&&arguments[1]!==undefined?arguments[1]:false;var inValid=!validations.isEmpty(value);if(returnBoolean)return inValid;var errorMessage=inValid&&"is empty";var message={error:inValid,message:errorMessage};return message},hasMinimalCharacters:function hasMinimalCharacters(value){var validateBy=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{length:1};return inValidCharactersLength(value,validateBy.length)},hasMaximumCharacters:function hasMaximumCharacters(value){var validateBy=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{length:256};return inValidCharactersLength(value,validateBy.length,true)},hasMinimalAndMaximalCharacters:function hasMinimalAndMaximalCharacters(value){var validateBy=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{minCharacters:1,maxCharacters:256};var errorMessage="must have minimum ".concat(validateBy.minCharacters," and maximum ").concat(validateBy.maxCharacters," characters");var isEmpty=validations.isEmpty(value);if(isEmpty){return{error:isEmpty,message:errorMessage}}var inValidMinimumLength=inValidCharactersLength(value,validateBy.minCharacters,true,true);var inValidMaximumLength=inValidCharactersLength(value,validateBy.maxCharacters,false,true);var inValid=inValidMinimumLength||inValidMaximumLength;var message={error:inValid,message:inValid&&errorMessage};return message},startAndEndsWith:function startAndEndsWith(value){var validateBy=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{firstCharacter:[],lastCharacter:[]};var errorMessage="must be started with ".concat(validateBy.firstCharacter.join(",")," and ended with ").concat(validateBy.lastCharacter.join(","));var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:isEmpty,message:errorMessage};var isValid=validateBy.firstCharacter.includes(value.slice(0,1))&&validateBy.lastCharacter.includes(value.slice(-1));var message={error:!isValid,message:!isValid&&errorMessage};return message},notStartedWith:function notStartedWith(value){var validateBy=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{notAllowed:[],caseSensitive:true};var caseSensitive=validateBy.caseSensitive&&validations.isBoolean(validateBy.caseSensitive)?!!JSON.parse(validateBy.caseSensitive):true;var errorMessage="can not started with ".concat(validateBy.notAllowed.join(", ")," (is ").concat(!caseSensitive?"not ":"","case sensitive)").replace(",  ",", spaces").replace("  ,"," spaces,");var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var notAllowed=validateBy.notAllowed.map(function(tempValue){return caseSensitive?tempValue:tempValue.toLowerCase()});var valueAsString=validations.isJSONString(value)?JSON.stringify(value):value.trim();var firstCharacter=caseSensitive?valueAsString[0]:valueAsString[0].toLowerCase();var inValid=notAllowed.includes(firstCharacter);var message={error:inValid,message:inValid?errorMessage:undefined};return message},containsNot:function containsNot(value){var validateBy=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{notAllowed:[],caseSensitive:true};var returnBoolean=arguments.length>2&&arguments[2]!==undefined?arguments[2]:false;var caseSensitive=validateBy.caseSensitive&&validations.isBoolean(validateBy.caseSensitive)?!!JSON.parse(validateBy.caseSensitive):true;var errorMessage="can not contain ".concat(validateBy.notAllowed.join(",")," (is ").concat(!caseSensitive?"not ":"","case sensitive)").replace(",  ",", spaces").replace("  ,"," spaces,");var isEmpty=validations.isEmpty(value);if(isEmpty){if(returnBoolean)return true;return{error:true,message:errorMessage}}var valueAsString=validations.isJSONString(value)?JSON.stringify(value):value.trim();var validatedValue=caseSensitive?valueAsString:valueAsString.toLowerCase();var inValid=false;validateBy.notAllowed.map(function(hasNot){var tempHasNot=caseSensitive?hasNot:hasNot.toLowerCase();if(validatedValue.indexOf(tempHasNot)>-1)inValid=true;return inValid});if(returnBoolean)return inValid;var message={error:inValid,message:inValid?errorMessage:undefined};return message},isNot:function isNot(value){var validateBy=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{notAllowed:[],caseSensitive:true};var caseSensitive=validateBy.caseSensitive&&validations.isBoolean(validateBy.caseSensitive)?!!JSON.parse(validateBy.caseSensitive):true;var errorMessage="is not one off ".concat(validateBy.notAllowed.join(", ")," (is ").concat(!caseSensitive?"not ":"","case sensitive)").replace(",  ",", spaces").replace("  ,"," spaces,");var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var validateValue=(0,_getType["default"])(value)==="string"?value.trim():value;if(!caseSensitive&&(0,_getType["default"])(validateValue)==="string"){validateValue=validateValue.toLowerCase()}var inValid=false;validateBy.notAllowed.map(function(isNot){var tempIsNot=!caseSensitive&&(0,_getType["default"])(isNot)==="string"?isNot.toLowerCase():isNot;if(validateValue===tempIsNot)inValid=true;return inValid});var message={error:inValid,message:inValid?errorMessage:undefined};return message},isExact:function isExact(value){var validateBy=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{isExact:[],caseSensitive:true};var caseSensitive=validateBy.caseSensitive&&validations.isBoolean(validateBy.caseSensitive)?!!JSON.parse(validateBy.caseSensitive):true;var errorMessage="is not one off ".concat(validateBy.isExact.join(", ")," (is ").concat(!caseSensitive?"not ":"","case sensitive)").replace(",  ",", spaces").replace("  ,"," spaces,");var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var validateValue=(0,_getType["default"])(value)==="string"?value.trim():value;if(!caseSensitive&&(0,_getType["default"])(validateValue)==="string"){validateValue=validateValue.toLowerCase()}var isExact=validateBy.isExact.map(function(tempValue){if(!caseSensitive&&(0,_getType["default"])(tempValue)==="string"){return tempValue.toLowerCase()}return tempValue});var isValid=isExact.includes(validateValue);var message={error:!isValid,message:!isValid?errorMessage:undefined};return message},number:function number(value){var returnBoolean=arguments.length>1&&arguments[1]!==undefined?arguments[1]:false;var errorMessage="is not a number";var isEmpty=validations.isEmpty(value);if(isEmpty){if(returnBoolean)return false;return{error:true,message:errorMessage}}if((0,_getType["default"])(value)==="number"&&!Number.isNaN(value)){if(returnBoolean)return true;return{error:false,message:undefined}}if((0,_getType["default"])(value)==="string"){if(value.startsWith("00")||value.startsWith("-00")){if(returnBoolean)return false;return{error:true,message:errorMessage}}var pattern=/^[-]?[\d]*[.]?[\d]*([eE][-+]?[\d]+)?$/;var isValid=pattern.test(value);if(returnBoolean)return isValid;return{error:!isValid,message:!isValid?errorMessage:undefined}}if(returnBoolean)return false;return{error:true,message:errorMessage}},numberIsOrBetween:function numberIsOrBetween(value){var validateBy=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{minimal:-2147483648,maximum:2147483648};var errorMessage="number is not between ".concat(validateBy.minimal," and ").concat(validateBy.maximum);var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var validateValue=(0,_getType["default"])(value)==="string"?value.trim():value;if(!validations.number(validateValue))return{error:true,message:errorMessage};var valueAsPointedNumber=parseFloat(validateValue);if(valueAsPointedNumber>=validateBy.minimal&&valueAsPointedNumber<=validateBy.maximum)return{error:false,message:undefined};return{error:true,message:errorMessage}},"float":function float(value){var validateBy=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{maxDecimals:Infinity};var errorMessage="is not a float number";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var validateValue=(0,_getType["default"])(value)==="string"?value.trim():value;if(!validations.number(validateValue))return{error:true,message:errorMessage};var splittedValue=(0,_getType["default"])(validateValue)==="string"?validateValue.split("."):validateValue.toString().split(".");if(splittedValue.length!==2)return{error:true,message:errorMessage};if((0,_getType["default"])(validateBy.maxDecimals)==="number"){if(validateBy.maxDecimal!==Infinity)errorMessage="".concat(errorMessage," with maximum ").concat(validateBy.maxDecimal," decimals");var isValid=splittedValue[1].length<=validateBy.maxDecimals;return{error:!isValid,message:!isValid?errorMessage:undefined}}return{error:true,message:errorMessage}},alphabetic:function alphabetic(value){var errorMessage="is not alphabetic";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var pattern=/^[a-zA-Z\s]+$/;var isValid=pattern.test(value);return{error:!isValid,message:!isValid?errorMessage:undefined}},alphanumeric:function alphanumeric(value){var errorMessage="is not alphanumeric";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var pattern=/^[\w\s]+$/;var isValid=pattern.test(value);return{error:!isValid,message:!isValid?errorMessage:undefined}},tel:function tel(value){var errorMessage="is not a phonenumber";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var pattern=/^(?:\+\d{1,3}|0\d{1,3}|00\d{1,2})?(?:\s?\(\d+\))?(?:[-/\s.]|\d)+$/;var isValid=pattern.test(value);return{error:!isValid,message:!isValid?errorMessage:undefined}},isBoolean:function isBoolean(value){var errorMessage="is not a boolean";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};if((0,_getType["default"])(value)==="boolean")return{error:false,message:undefined};if((0,_getType["default"])(value)==="string"&&validations.isExact(value,{isExact:["0","1","true","false"],caseSensitive:false}))return{error:false,message:undefined};return{error:true,message:errorMessage}},dateFuture:function dateFuture(value){var errorMessage="is not a valid date in the future";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var date={};if((0,_getType["default"])(date)==="object"){var tempDate=value.split("-");date={year:parseInt(tempDate[0],10),month:parseInt(tempDate[1],10)-1,day:parseInt(tempDate[2],10)}}var temp=new Date(date.year,date.month,date.day);var now=new Date;if(now<temp&&temp.getDate()===date.day&&temp.getMonth()===date.month&&temp.getFullYear()===date.year)return{error:false,message:undefined};return{error:true,message:errorMessage}},password:{weak:function weak(value){var errorMessage="password must be between 6 and 256 characters which contain only characters, numeric digits and underscore and first character must be a letter";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var pattern=/^[A-Za-z]\w{6,256}$/;var isValid=pattern.test(value);return{error:!isValid,message:!isValid?errorMessage:undefined}},medium:function medium(value){var errorMessage="password must be between 6 to 256 characters which contain at least one numeric digit, one uppercase and one lowercase letter";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var pattern=/^(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{6,256}$/;var isValid=pattern.test(value);return{error:!isValid,message:!isValid?errorMessage:undefined}},strong:function strong(value){var errorMessage="password must be between 7 to 256 characters which contain at least one numeric digit and a special character";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var pattern=/^(?=.*[0-9])(?=.*[!@#$%^&*])[a-zA-Z0-9!@#$%^&*]{7,21}$/;var isValid=pattern.test(value);return{error:!isValid,message:!isValid?errorMessage:undefined}},veryStrong:function veryStrong(value){var errorMessage="password must be between 8 to 256 characters which contain at least one lowercase letter, one uppercase letter, one numeric digit, and one special character";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var pattern=/^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[^a-zA-Z0-9])(?!.*\s).{8,256}$/;var isValid=pattern.test(value);return{error:!isValid,message:!isValid?errorMessage:undefined}}},ipadress:function ipadress(value){var errorMessage="is not a valid ip address";var isEmpty=validations.isEmpty(value);if(isEmpty)return{error:true,message:errorMessage};var pattern=/((^\s*((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))\s*$)|(^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$))/;var isValid=pattern.test(value);return{error:!isValid,message:!isValid?errorMessage:undefined}},isJSONString:function isJSONString(value){if(validations.isEmpty(value))return false;var validateValue=(0,_getType["default"])(value)==="string"?value.trim():value;if((0,_getType["default"])(validateValue)==="string"&&(validateValue.slice(0,1)==="."||validateValue.slice(-1)==="."||validateValue==="-"))return false;if((0,_getType["default"])(validateValue)==="string"&&validateValue.length>1&&validateValue[0]==="0")return false;if((0,_getType["default"])(validateValue)==="number"&&validateValue!==Infinity)return true;if(validations.number(value,true))return true;var isValidNumber=validations.number(validateValue);if(isValidNumber&&!isValidNumber.error)return true;if((0,_getType["default"])(validateValue)!=="string")return false;if(["true","false","null"].includes(validateValue))return true;var isValid=validations.startAndEndsWith(validateValue,{firstCharacter:["{","["],lastCharacter:["}","]"]});if(isValid&&!isValid.error){return["object","array"].includes((0,_getType["default"])(JSON.parse(validateValue)))}return false},multipleValidation:function multipleValidation(value){var validationTypes=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};var error=[];Object.keys(validationTypes).map(function(validationType){var response=validations[validationType](value,validationTypes[validationType]);if(!response){error.push("Create error message for ".concat(validationType))}if(response&&response.error)error.push(response.message);return error});return error}};exports.validations=validations;var formPostValidation=function formPostValidation(postData){if(!postData||(0,_getType["default"])(postData)!=="object")return undefined;var postDataKeys=Object.keys(postData);var errorMessages={};if(!postDataKeys.length)return undefined;postDataKeys.forEach(function(formElementKey){var formElement=postData[formElementKey];var elementRequired=formElement.required||false;if(!elementRequired)return;var elementValidationTypes=formElement.validationTypes||{};var totalValidationTypes=Object.keys(elementValidationTypes).length||0;var value=formElement.values;var errorMessage=[];if(!totalValidationTypes&&elementRequired&&validations.isEmpty(value).error){errorMessage.push("Cann't be empty")}if(totalValidationTypes)errorMessage=validations.multipleValidation(value,elementValidationTypes);if(errorMessage.length)errorMessages[formElementKey]=errorMessage});if(Object.keys(errorMessages).length)return errorMessages;return undefined};exports.formPostValidation=formPostValidation;var getValidationTypes=function getValidationTypes(){var dataRequired=arguments.length>0&&arguments[0]!==undefined?arguments[0]:false;var dataValidationTypes=arguments.length>1?arguments[1]:undefined;var required=validations.isBoolean(dataRequired)?dataRequired:false;if(!required)return undefined;var validationTypes=validations.isJSONString(dataValidationTypes)?JSON.parse(dataValidationTypes):undefined;var totalValidationTypes=validationTypes?Object.keys(validationTypes).length:undefined;if(!totalValidationTypes&&required)return{isNotEmpty:null};return validationTypes};exports.getValidationTypes=getValidationTypes;var isElementValid=function isElementValid(validationTypes,value){if(!validationTypes||(0,_getType["default"])(validationTypes)!=="object")return"isValid";var totalValidationTypes=Object.keys(validationTypes).length;if(!totalValidationTypes)return"isValid";if(validations.isEmpty(value))return"isEmpty";var errorMessages=validations.multipleValidation(value,validationTypes);return!errorMessages.length?"isValid":"inValid"};exports.isElementValid=isElementValid;