"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.clearStorage=exports.removeStorageItem=exports.setStorageItem=exports.getStorageItem=void 0;var _validations=require("../validations");var _getType=_interopRequireDefault(require("../getType"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{"default":obj}}var isValidStorageType=function isValidStorageType(storageType){var storageTypes=["localStorage","sessionStorage"];return storageTypes.includes(storageType)};var getStorageItem=function getStorageItem(key){var storageType=arguments.length>1&&arguments[1]!==undefined?arguments[1]:"localStorage";if(!key)return undefined;if(!isValidStorageType(storageType))return undefined;var value=window[storageType].getItem(key);if(!_validations.validations.isNotEmpty(value))return undefined;var parseValue=_validations.validations.isJSONString(value);return parseValue?JSON.parse(value):value};exports.getStorageItem=getStorageItem;var setStorageItem=function setStorageItem(key,value){var storageType=arguments.length>2&&arguments[2]!==undefined?arguments[2]:"localStorage";if(!key)return undefined;if(!isValidStorageType(storageType))return undefined;var valueType=(0,_getType["default"])(value);var valueAsString;if(valueType==="string")valueAsString=value;if(["array","object","number","boolean"].includes(valueType))valueAsString=JSON.stringify(value);if(valueAsString===undefined)return undefined;window[storageType].setItem(key,valueAsString);return true};exports.setStorageItem=setStorageItem;var removeStorageItem=function removeStorageItem(key){var storageType=arguments.length>1&&arguments[1]!==undefined?arguments[1]:"localStorage";if(!key)return undefined;if(!isValidStorageType(storageType))return undefined;window[storageType].removeItem(key);return true};exports.removeStorageItem=removeStorageItem;var clearStorage=function clearStorage(){var storageType=arguments.length>0&&arguments[0]!==undefined?arguments[0]:"localStorage";if(!isValidStorageType(storageType))return undefined;window[storageType].clear();return true};exports.clearStorage=clearStorage;